#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <windows.h>

double PCFreq = 0.0;
__int64 CounterStart = 0;

void StartCounter()
{
    LARGE_INTEGER li;
    if (!QueryPerformanceFrequency(&li))
    printf("QueryPerformanceFrequency failed!\n");

    PCFreq = ((double)(li.QuadPart))/1000.0;

    QueryPerformanceCounter(&li);
    CounterStart = li.QuadPart;
}

double GetCounter()
{
    LARGE_INTEGER li;
    QueryPerformanceCounter(&li);
    return (double)((li.QuadPart-CounterStart)/PCFreq);
}

double f(double x);
double f(double x)
{
  return (4.0 / (1.0 + x*x));
}

double pi_calculate(const long int n);
double pi_calculate(const long int n)
{
  long int i;
  double x,h,sum;
  h = 1.0 / (double) n;
  sum = 0.0;
  for (i=1; i<=n; i++){
    x = h * ((double)i - 0.5);
    sum += f(x);
  }
  return h*sum;
}

int main()
{
  double t, mypi;
  double sum;
  long int i, n=1;

  StartCounter();

  sum = 0;
  for (i=0; i<n; i++) {
    mypi = pi_calculate(1000000000);
    sum += mypi;
  }
  sum /= (1.0*n);

  t = 1e-3 * GetCounter();

  printf("Time: %le sec mypi=%14.12lf sum=%14.12lf\n", t, mypi, sum);

  return 0;
}